<?php
namespace Teknisa\MAN\Controllers;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\MAN\Services\RelEvoVendasService;
use Teknisa\MAN\Services;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO\Response\Error;    

class RelEvoVendas  extends  CrudWithParameterBag { 
    
    
    protected $utilService;
              
    public function __construct ($crudService, $parameterBag, $entityManager, Utilities\Util $utilService, Manager $dataSourceManager,
                                 RelEvoVendasService $RelEvoVendasService, BirtReport $birtReport, ReportService $reportService) {
        $this->crudService          = $crudService;
        $this->parameterBag         = $parameterBag;
        $this->entityManager        = $entityManager;
        $this->utilService          = $utilService;
        $this->dataSourceManager    = $dataSourceManager;
        $this->EvoVendasService     = $RelEvoVendasService;
        $this->birtReport           = $birtReport;
        $this->reportService        = $reportService;
    }
     
    public function findRelatorio(DTO\Request\Row $request, DTO\Response $response) {
        $conditions = $this->utilService->getParamsAsArray($request);
        $params     = $this->EvoVendasService->buildReportParams($conditions);
        $this->getReport($params, $response);
    }

    public function getReport($params, DTO\Response $response){
        try {
            $birtURL = $this->reportService->createRemoteReport('BIRT', $params['ReportName'], $params['ParametersRow']);
            $response->addDataset(new DataSet('URL',array('url'=>$birtURL)));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage() , 500));
        }
    }
    
    
}